import java.util.*;
import java.io.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class KalahServer implements ActionListener{
	private static int LOGLEVEL = 4;
	private static long WAITTIME = 3000l;
	
	private static BufferedReader AOut, BOut, AErr, BErr;
	private static PrintWriter AIn, BIn;
	private static cBoard kb;
	private static JButton[] Bowls;
	private static JButton MoveB;
	private static JFrame jf;
	private static boolean bAuto=false;
	private static long StartTime;
	private static int numErrors;
	private static MyTableModel mtm;
	private static JTable jtab;
	private static String ServerStr;
// 	player names
	private static String P1Str;
	private static String P2Str;
	
	public static void main(String args[]) {
		kb = new cBoard();
		int i;
		cLog.level=LOGLEVEL;
		try{
			Process ClientA = Runtime.getRuntime().exec(args[0]+" 1");
			Process ClientB = Runtime.getRuntime().exec(args[1]+" 2");
			
			if ( (i=args[0].lastIndexOf(" ")) > -1) P1Str = args[0].substring(i);
			else P1Str = args[0];
			if ( (i=args[1].lastIndexOf(" ")) > -1) P2Str = args[1].substring(i);
			else P2Str = args[1];
			
			
			if (args.length>2 && args[2].equals("-a")){
				bAuto=true;
				ServerStr = "KalahServer v1.0(auto) - ";
			}else ServerStr = "KalahServer v1.0 - ";
			
			AOut = new BufferedReader(new InputStreamReader(ClientA.getInputStream()));
			BOut = new BufferedReader(new InputStreamReader(ClientB.getInputStream()));
		
			AErr = new BufferedReader(new InputStreamReader(ClientA.getErrorStream()));
			BErr = new BufferedReader(new InputStreamReader(ClientB.getErrorStream()));
			
			//read the annoying errors msgs
// 			for (i=0;i<20;i++) 
			while (AErr.ready()) AErr.readLine();
// 			for (i=0;i<20;i++)
			while (BErr.ready()) BErr.readLine();
			
			AIn = new PrintWriter(new OutputStreamWriter(ClientA.getOutputStream()));
			BIn = new PrintWriter(new OutputStreamWriter(ClientB.getOutputStream()));
		
		}catch (Exception e) {
			cLog.Log(0,"Init","Exception:");
        		e.printStackTrace();
        	}
		KalahServer ms = new KalahServer();
		
	}
	
	public KalahServer(){
		makeWnd();
	}
	
	public void actionPerformed(ActionEvent e){
		int i,m,w;
		long time;
		int[] entry = new int[6];
		
		
		if (e.getActionCommand().equals("Gen")){
			MoveB.setEnabled(false);
			byte n = kb.getNext();	
			entry[1]= n+1;			//player
			
			try{
				//search
				OutputErrors();
				cLog.Log(1,"Gen","Generating move for P"+(n+1)+",e="+kb.eval(n));
				
				StartTime = System.currentTimeMillis();
				if(n==0) m=gameloop(AIn,BIn,AOut);
				else m=gameloop(BIn,AIn,BOut);
				time = 	System.currentTimeMillis() - StartTime;
// 				move table entries
				entry[2] = m;			//picked bowl
				entry[5] = (int)time;		//time
				
				if (m>-1){
					entry[3] = kb.getBowl(m);	//stones moved
					w = kb.getBowlD(6);		//old stones in kalah
					kb.move(m);
					entry[4] = kb.getBowl(6+n*7)-w; //stones won
					
					cLog.Log(1,"Gen","Player"+(n+1)+" chose bowl"+m+" after "
					+time+"ms,e="+kb.eval(n));
					cLog.Log(3,"Gen","Gameboard is:"+kb);
				}else numErrors++;
				OutputErrors();
				
				
			}catch (Exception ex) {
				cLog.Log(0,"Gen","Exception: ");
				ex.printStackTrace();
				numErrors++;
			}
			
			int state[] = kb.getState();
			for (i=0;i<14;i++)
				Bowls[i].setText(new Integer(state[i]).toString());
			jf.setTitle(ServerStr+"turn P"+(kb.getNext()+1));
			if (!bAuto) MoveB.setEnabled(true);
				
			
// 			update the move table
			mtm.newEntry(entry);
			jtab.setRowSelectionInterval(jtab.getRowCount()-1,jtab.getRowCount()-1);
			jtab.scrollRectToVisible(jtab.getCellRect(jtab.getRowCount()-1,1,true));
			jtab.repaint();
			
			if (!kb.isAlive()){
			
				MoveB.setEnabled(false);
				String msg;
				int[] balls=kb.getState();
				String t="";
				if (balls[6]==balls[13]) t="draw";
				else if(balls[6]>balls[13]) t="P1 won";
				else t="P2 won";
				jf.setTitle(ServerStr+t);
			
				
				if (balls[6]==balls[13]) msg="Nobody won; 36:36";
				else msg="Player"+((balls[6]>balls[13])?"1":"2") +" won; "+
				   ((balls[6]>balls[13])?balls[6]:balls[13]) + ":" +
				   ((balls[6]>balls[13])?balls[13]:balls[6]);
				cLog.Log(1,"Kalah","Game over, "+msg);
		
				AIn.println("quit");
				AIn.flush();
				BIn.println("quit");
				BIn.flush();
			}
			jf.repaint();
			
			//and call the press-button routine again in 500ms
			if (bAuto && numErrors<10 && kb.isAlive()){
				java.util.Timer t = new java.util.Timer();
				t.schedule(new tt(),WAITTIME);
			}else if(numErrors>=10){
				cLog.Log(1,"Kalah","too many errors");
				MoveB.setEnabled(true);
				numErrors=0;
			}
		}	
	}
	
	
	private static int gameloop(PrintWriter P1In, PrintWriter P2In, BufferedReader P1Out)
	throws IOException{
		String newmove=null;
		long movetime;
		
		OutputErrors();
		try{
			P1In.println("move"); 
			P1In.flush();
		}catch(Exception e){
			e.printStackTrace();
		}
		OutputErrors();
		movetime = System.currentTimeMillis();
		while(newmove==null && ((System.currentTimeMillis()-movetime)<6000) ){
			try{
				newmove = P1Out.readLine();
			}catch(Exception e){
				e.printStackTrace();
			}
		}
		
		OutputErrors();
		if (newmove!=null && newmove!=""){
			P2In.println("opponent " + newmove);
			P2In.flush();
			OutputErrors();
			return Integer.parseInt(newmove);
		}else return (-1);
	}
	//class for just pressing the button again ;)
	private class tt extends TimerTask{
		public void run(){
			actionPerformed(new ActionEvent(this,0,"Gen"));
		}
	}
		
	private static void OutputErrors(){
// 		cLog.Log(0,"Error","/* Errors */");
		try{	
			while (AErr.ready()) cLog.Log(0,"AError",AErr.readLine());
			while (BErr.ready()) cLog.Log(0,"BError",BErr.readLine());
		}catch(Exception e){
			e.printStackTrace();
		}
// 		cLog.Log(0,"Error","/* ------ */");
	}
	
	private void makeWnd(){
		int i;
		JPanel jp = new JPanel(new GridLayout(2,1,5,5));
		JPanel jp1 = new JPanel(new BorderLayout(5,5));
		jp1.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
		
		//make GenMove Pane
		MoveB = new JButton("Gen");
		MoveB.setActionCommand("Gen");
		MoveB.addActionListener(this);
		jp1.add(MoveB,BorderLayout.NORTH);
		
		//make pane for the board
		JPanel jpborder = new JPanel(new BorderLayout(2,2));
		jpborder.setBorder(BorderFactory.createLineBorder(Color.black));
		
		JPanel jpboard = new JPanel(new BorderLayout(10,10));
		jpboard.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
		jpborder.add(jpboard);
		
		Bowls = new JButton[14];
		//add two kalahs
		JButton jb = new JButton();
		jb.setEnabled(false);
		Bowls[6]=jb;
		jpboard.add(jb,BorderLayout.EAST);
		
		jb = new JButton();
		jb.setEnabled(false);
		Bowls[13]=jb;
		jpboard.add(jb,BorderLayout.WEST);
		
		//make panel and add bowls
		JPanel jp3 = new JPanel();
		jp3.setLayout(new GridLayout(2,6,20,20));
		
		//make bowls
		for (i=12;i>6;i--){
			jb = new JButton();
			jb.setActionCommand(new Integer(i).toString());
			jb.addActionListener(this);
			jb.setEnabled(false);
			Bowls[i]=jb;
			jp3.add(jb);
			
		}
		for (i=0;i<6;i++){
			jb = new JButton();
			jb.setActionCommand(new Integer(i).toString());
			jb.addActionListener(this);
			jb.setEnabled(false);
			Bowls[i]=jb;
			jp3.add(jb);
		}
		jpboard.add(jp3,BorderLayout.CENTER);
		//and put the to contestants's names
		jpboard.add(new JLabel(P1Str,JLabel.CENTER),BorderLayout.SOUTH);
		jpboard.add(new JLabel(P2Str,JLabel.CENTER),BorderLayout.NORTH);
		
// 		put the moves table...
		jtab = new JTable(mtm=new MyTableModel());
		JScrollPane scrollPane = new JScrollPane(jtab);
		jtab.setPreferredScrollableViewportSize(new Dimension(570, 150));
		
// 		and put everything together
		jp1.add(jpborder,BorderLayout.CENTER);
		
		jp.add(jp1);
		jp.add(scrollPane);
		
		jf = new JFrame(ServerStr);
		jf.setDefaultCloseOperation(jf.EXIT_ON_CLOSE);
		jf.setSize(580,400);
		
		jf.getContentPane().add(jp);
		
		
		//update board and alive
		int state[] = kb.getState();
		for (i=0;i<14;i++)
			Bowls[i].setText(new Integer(state[i]).toString());
		jf.setTitle(ServerStr+"turn P"+(kb.getNext()+1));
		jf.setVisible(true);
		//and fire up the button
		if (bAuto){java.util.Timer t = new java.util.Timer();
				t.schedule(new tt(),100l);}
		
	}
	
	private class MyTableModel extends javax.swing.table.AbstractTableModel {
    		private String[] columnNames = {"Move#","Player","Bowl","Stones moved","Stones won","Time/ms"};
    		public Vector data = new Vector();
		
		public void newEntry(int[] d) {
        		d[0]=data.size()+1;
			data.add(d);
        		fireTableRowsInserted(data.size(),data.size());
    		}
		public int getColumnCount() {
        		return columnNames.length;
    		}

    		public int getRowCount() {
        		return data.size();
    		}

    		public String getColumnName(int col) {
        		return columnNames[col];
    		}

    		public Object getValueAt(int row, int col) {
        		Object ret;
			int i;
			if (col==1){
				i = ((int[])data.get(row))[1];
				ret = "  " + i + "   (" +( (i==1)?P1Str:P2Str )+")";
			}else ret = new Integer(((int[])data.get(row))[col]);
			return ret;
    		}

    		public Class getColumnClass(int c) {
        		return (c==1)?String.class:Integer.class;
    		}
		public boolean isCellEditable(int row, int col) {
     		       return false;
        	}
    }
	
}
