/* Class cMTDF
 * static class which implements MTDF
 * uses AlphaBeta with a memory enhancement, i.e. Hastable
*/

import java.util.*;

public class cMTDF{
	
	//Hastable for Pos lookup
    	public  static Hashtable ht = new Hashtable();
	public  static int[] MoveTab = new int[6];
	private static byte side;
	
	//the real MTDF algo...
	public static int MTDF(cBoard kb, int f, int d){
		int g = f;
		int upBound = Integer.MAX_VALUE, lowBound=-Integer.MIN_VALUE; //is a little more than possible values
		int beta;
		side=kb.getNext();
		
		do{
			if (g==lowBound) beta = g+1;
			else 		 beta = g;
			
			g = ABWithMem(kb,beta-1,beta,d);
			
			if (g<beta) 	upBound = g;
			else 		lowBound = g;
			cLog.Log(2,"MTDF","l:"+lowBound+",u:"+upBound+",g:"+g);
		}while(lowBound<upBound);	
		return g;
	}
	
	/* AlphaBeta with storing nodes in a hastable for lookup */
	private static int ABWithMem(cBoard kb, int alpha, int beta, int d){
		int g,a,b,i,t;
		cBoard.cMove m;
		cBoard help = new cBoard();
		//table lookup
		cBoard n = (cBoard)ht.get(kb);
		if ( null!=n && n.depth>=d  ){		//ht hit: 
				//only if we searched already deeper than we would right now
			cLog.Log(5,"ABM","HT hit");	
			if (n.lBound>=beta) return n.lBound;	// see if we can return ;)
			if (n.uBound<=alpha) return n.uBound;	//if bounds greater than current, return
			alpha = Math.max(alpha,n.lBound);
			beta = Math.min(beta,n.uBound);
		}
		n = kb;
		cLog.Log(3,"ABM",kb+","+alpha+","+beta+","+d+","+(n.getNext()==side));
		//generate the moves...
		Vector moves = n.genMoves(side);
		
		//check quiescene...
		if (d==0 && !n.isQuiescence()){
			cLog.Log(5,"ABM","!Quiescence hit");
			d++;
		}
		if (d==0 || !n.isAlive()){
			g=n.eval(side);
			cLog.Log(5,"ABM","eval hit");
		//next player are still we, i.e. MAXNODE
		}else if(n.getNext()==side){
			g=Integer.MIN_VALUE;a=alpha;
			i=0;
			//g<beta ensures alpha pruning
			while (i<6 && g<beta){
				//the cMove element of this move
				m = (cBoard.cMove)moves.elementAt(i);	//int m.m = move, int m.e = depth-extension
				//dont do moves with no balls
				if (n.getBowlD(m.m)<1){ i++; continue; }
				//generate next Board state
				help.copy(n);
				
				//make move
				help.move(m.m);
				t = ABWithMem(help,a,beta,d-1+m.e);
				if (t>g) n.bestMove = m.m;
				g = Math.max(g,t);
				a = Math.max(a,g);
				
				//and store move in MoveTable
				//if (t>MoveTab[m.m]) 
				MoveTab[m.m]=t;
				
				i++;
			}
		//MINNODE
		}else{		
			g=Integer.MAX_VALUE;b=beta;
			i=0;
			//g>alpha ensures beta pruning
			while (i<6 && g>alpha){
				//the cMove element of this move
				m = (cBoard.cMove)moves.elementAt(i);	//int m.m = move, int m.e = extension
				//dont do moves with no balls
				if (n.getBowlD(m.m)<1) { i++; continue; }
				//generate next Board state
				help.copy(n);
				
				help.move(m.m);
				t = ABWithMem(help,alpha,b,d-1+m.e);
				if (t<g) n.worstMove = m.m;
				g = Math.min(g,t);
				b = Math.min(b,g);
				i++;
			}
		}
		//store move and bounds of that move in Transp. table
		//fail low implies upper bound
		if (g<=alpha) n.uBound=g;
		//found accurate minimax val
		else if (g>alpha && g<beta) n.lBound=n.uBound=g;
		//fail high implies lower bound
		else if (g>=beta) n.lBound=g;
		cLog.Log(3,"ABM","got l:"+n.lBound+",u:"+n.uBound+",g:"+g);
		//store depth
 		n.depth = d;
 		//and put into HT	
		ht.put(n,n);
		
		return g;
	}
	
}
